NMDevice
3
LIBNM-GLIB Library

# NMDevice

## Synopsis

    #define             NM_DEVICE_UDI
    #define             NM_DEVICE_INTERFACE
    #define             NM_DEVICE_DRIVER
    #define             NM_DEVICE_CAPABILITIES
    #define             NM_DEVICE_MANAGED
    #define             NM_DEVICE_IP4_CONFIG
    #define             NM_DEVICE_DHCP4_CONFIG
    #define             NM_DEVICE_STATE
    #define             NM_DEVICE_VENDOR
    #define             NM_DEVICE_PRODUCT
                        NMDevice;
    GObject*            nm_device_new                       (DBusGConnection *connection,
                                                             const char *path);
    const char*         nm_device_get_iface                 (NMDevice *device);
    const char*         nm_device_get_udi                   (NMDevice *device);
    const char*         nm_device_get_driver                (NMDevice *device);
    guint32             nm_device_get_capabilities          (NMDevice *device);
    gboolean            nm_device_get_managed               (NMDevice *device);
    NMIP4Config*        nm_device_get_ip4_config            (NMDevice *device);
    NMDHCP4Config*      nm_device_get_dhcp4_config          (NMDevice *device);
    NMDeviceState       nm_device_get_state                 (NMDevice *device);
    const char*         nm_device_get_product               (NMDevice *device);
    const char*         nm_device_get_vendor                (NMDevice *device);

## Object Hierarchy

      GObject
       +----NMObject
             +----NMDevice
                   +----NMDeviceEthernet
                   +----NMDeviceWifi
                   +----NMSerialDevice

## Properties

      "capabilities"             guint                 : Read
      "dhcp4-config"             NMDHCP4Config         : Read
      "driver"                   gchararray            : Read
      "interface"                gchararray            : Read
      "ip4-config"               NMIP4Config           : Read
      "managed"                  gboolean              : Read
      "product"                  gchararray            : Read
      "state"                    guint                 : Read
      "udi"                      gchararray            : Read
      "vendor"                   gchararray            : Read

## Signals

      "state-changed"                                  : Run First

## Description

## Details

### NM_DEVICE_UDI

    #define NM_DEVICE_UDI "udi"

### NM_DEVICE_INTERFACE

    #define NM_DEVICE_INTERFACE "interface"

### NM_DEVICE_DRIVER

    #define NM_DEVICE_DRIVER "driver"

### NM_DEVICE_CAPABILITIES

    #define NM_DEVICE_CAPABILITIES "capabilities"

### NM_DEVICE_MANAGED

    #define NM_DEVICE_MANAGED "managed"

### NM_DEVICE_IP4_CONFIG

    #define NM_DEVICE_IP4_CONFIG "ip4-config"

### NM_DEVICE_DHCP4_CONFIG

    #define NM_DEVICE_DHCP4_CONFIG "dhcp4-config"

### NM_DEVICE_STATE

    #define NM_DEVICE_STATE "state"

### NM_DEVICE_VENDOR

    #define NM_DEVICE_VENDOR "vendor"

### NM_DEVICE_PRODUCT

    #define NM_DEVICE_PRODUCT "product"

### NMDevice

    typedef struct _NMDevice NMDevice;

### nm_device_new ()

    GObject*            nm_device_new                       (DBusGConnection *connection,
                                                             const char *path);

Creates a new NMDevice.

`connection` :

  the DBusGConnection

`path` :

  the DBus object path of the device

Returns :

  a new device

### nm_device_get_iface ()

    const char*         nm_device_get_iface                 (NMDevice *device);

Gets the interface name of the NMDevice.

`device` :

  a NMDevice

Returns :

  the interface of the device. This is the internal string used by the device, and must not be modified.

### nm_device_get_udi ()

    const char*         nm_device_get_udi                   (NMDevice *device);

Gets the HAL UDI of the NMDevice.

`device` :

  a NMDevice

Returns :

  the HAL UDI of the device. This is the internal string used by the device, and must not be modified.

### nm_device_get_driver ()

    const char*         nm_device_get_driver                (NMDevice *device);

Gets the driver of the NMDevice.

`device` :

  a NMDevice

Returns :

  the driver of the device. This is the internal string used by the device, and must not be modified.

### nm_device_get_capabilities ()

    guint32             nm_device_get_capabilities          (NMDevice *device);

Gets the device' capabilities.

`device` :

  a NMDevice

Returns :

  the capabilities

### nm_device_get_managed ()

    gboolean            nm_device_get_managed               (NMDevice *device);

Whether the NMDevice is managed by NetworkManager.

`device` :

  a NMDevice

Returns :

  `TRUE` if the device is managed by NetworkManager

### nm_device_get_ip4_config ()

    NMIP4Config*        nm_device_get_ip4_config            (NMDevice *device);

Gets the current NMIP4Config associated with the NMDevice.

`device` :

  a NMDevice

Returns :

  the NMIP4Config or `NULL` if the device is not activated.

### nm_device_get_dhcp4_config ()

    NMDHCP4Config*      nm_device_get_dhcp4_config          (NMDevice *device);

Gets the current NMDHCP4Config associated with the NMDevice.

`device` :

  a NMDevice

Returns :

  the NMDHCPConfig or `NULL` if the device is not activated or not using DHCP.

### nm_device_get_state ()

    NMDeviceState       nm_device_get_state                 (NMDevice *device);

Gets the current NMDevice state.

`device` :

  a NMDevice

Returns :

  the current device state

### nm_device_get_product ()

    const char*         nm_device_get_product               (NMDevice *device);

Gets the product string of the NMDevice.

`device` :

  a NMDevice

Returns :

  the product name of the device. This is the internal string used by the device, and must not be modified.

### nm_device_get_vendor ()

    const char*         nm_device_get_vendor                (NMDevice *device);

Gets the vendor string of the NMDevice.

`device` :

  a NMDevice

Returns :

  the vendor name of the device. This is the internal string used by the device, and must not be modified.

## Property Details

### The `"capabilities"` property

      "capabilities"             guint                 : Read

The capabilities of the device.

Default value: 0

### The `"dhcp4-config"` property

      "dhcp4-config"             NMDHCP4Config         : Read

The NMDHCP4Config of the device.

### The `"driver"` property

      "driver"                   gchararray            : Read

The driver of the device.

Default value: NULL

### The `"interface"` property

      "interface"                gchararray            : Read

The interface of the device.

Default value: NULL

### The `"ip4-config"` property

      "ip4-config"               NMIP4Config           : Read

The NMIP4Config of the device.

### The `"managed"` property

      "managed"                  gboolean              : Read

Whether the device is managed by NetworkManager.

Default value: FALSE

### The `"product"` property

      "product"                  gchararray            : Read

The product string of the device.

Default value: NULL

### The `"state"` property

      "state"                    guint                 : Read

The state of the device.

Default value: 0

### The `"udi"` property

      "udi"                      gchararray            : Read

The HAL UDI of the device.

Default value: NULL

### The `"vendor"` property

      "vendor"                   gchararray            : Read

The vendor string of the device.

Default value: NULL

## Signal Details

### The `"state-changed"` signal

    void                user_function                      (NMDevice *device,
                                                            guint     state,
                                                            guint     arg2,
                                                            guint     arg3,
                                                            gpointer  user_data)      : Run First

Notifies the state change of a NMDevice.

`device` :

  the client that received the signal

`state` :

  the new state of the device

`user_data` :

  user data set when the signal handler was connected.